import typing

import kubernetes.client

class PolicyV1beta1Api:
    def __init__(self, api_client: typing.Optional[kubernetes.client.ApiClient] = ...) -> None:
        ...
    def get_api_resources(self) -> kubernetes.client.V1APIResourceList:
        ...
    def list_namespaced_pod_disruption_budget(self, namespace: str, *, pretty: typing.Optional[str] = ..., allow_watch_bookmarks: typing.Optional[bool] = ..., _continue: typing.Optional[str] = ..., field_selector: typing.Optional[str] = ..., label_selector: typing.Optional[str] = ..., limit: typing.Optional[int] = ..., resource_version: typing.Optional[str] = ..., timeout_seconds: typing.Optional[int] = ..., watch: typing.Optional[bool] = ...) -> kubernetes.client.V1beta1PodDisruptionBudgetList:
        ...
    def create_namespaced_pod_disruption_budget(self, namespace: str, body: kubernetes.client.V1beta1PodDisruptionBudget, *, pretty: typing.Optional[str] = ..., dry_run: typing.Optional[str] = ..., field_manager: typing.Optional[str] = ...) -> kubernetes.client.V1beta1PodDisruptionBudget:
        ...
    def delete_collection_namespaced_pod_disruption_budget(self, namespace: str, *, pretty: typing.Optional[str] = ..., body: typing.Optional[kubernetes.client.V1DeleteOptions] = ..., _continue: typing.Optional[str] = ..., dry_run: typing.Optional[str] = ..., field_selector: typing.Optional[str] = ..., grace_period_seconds: typing.Optional[int] = ..., label_selector: typing.Optional[str] = ..., limit: typing.Optional[int] = ..., orphan_dependents: typing.Optional[bool] = ..., propagation_policy: typing.Optional[str] = ..., resource_version: typing.Optional[str] = ..., timeout_seconds: typing.Optional[int] = ...) -> kubernetes.client.V1Status:
        ...
    def read_namespaced_pod_disruption_budget(self, name: str, namespace: str, *, pretty: typing.Optional[str] = ..., exact: typing.Optional[bool] = ..., export: typing.Optional[bool] = ...) -> kubernetes.client.V1beta1PodDisruptionBudget:
        ...
    def replace_namespaced_pod_disruption_budget(self, name: str, namespace: str, body: kubernetes.client.V1beta1PodDisruptionBudget, *, pretty: typing.Optional[str] = ..., dry_run: typing.Optional[str] = ..., field_manager: typing.Optional[str] = ...) -> kubernetes.client.V1beta1PodDisruptionBudget:
        ...
    def delete_namespaced_pod_disruption_budget(self, name: str, namespace: str, *, pretty: typing.Optional[str] = ..., body: typing.Optional[kubernetes.client.V1DeleteOptions] = ..., dry_run: typing.Optional[str] = ..., grace_period_seconds: typing.Optional[int] = ..., orphan_dependents: typing.Optional[bool] = ..., propagation_policy: typing.Optional[str] = ...) -> kubernetes.client.V1Status:
        ...
    def patch_namespaced_pod_disruption_budget(self, name: str, namespace: str, body: typing.Any, *, pretty: typing.Optional[str] = ..., dry_run: typing.Optional[str] = ..., field_manager: typing.Optional[str] = ..., force: typing.Optional[bool] = ...) -> kubernetes.client.V1beta1PodDisruptionBudget:
        ...
    def read_namespaced_pod_disruption_budget_status(self, name: str, namespace: str, *, pretty: typing.Optional[str] = ...) -> kubernetes.client.V1beta1PodDisruptionBudget:
        ...
    def replace_namespaced_pod_disruption_budget_status(self, name: str, namespace: str, body: kubernetes.client.V1beta1PodDisruptionBudget, *, pretty: typing.Optional[str] = ..., dry_run: typing.Optional[str] = ..., field_manager: typing.Optional[str] = ...) -> kubernetes.client.V1beta1PodDisruptionBudget:
        ...
    def patch_namespaced_pod_disruption_budget_status(self, name: str, namespace: str, body: typing.Any, *, pretty: typing.Optional[str] = ..., dry_run: typing.Optional[str] = ..., field_manager: typing.Optional[str] = ..., force: typing.Optional[bool] = ...) -> kubernetes.client.V1beta1PodDisruptionBudget:
        ...
    def list_pod_disruption_budget_for_all_namespaces(self, *, allow_watch_bookmarks: typing.Optional[bool] = ..., _continue: typing.Optional[str] = ..., field_selector: typing.Optional[str] = ..., label_selector: typing.Optional[str] = ..., limit: typing.Optional[int] = ..., pretty: typing.Optional[str] = ..., resource_version: typing.Optional[str] = ..., timeout_seconds: typing.Optional[int] = ..., watch: typing.Optional[bool] = ...) -> kubernetes.client.V1beta1PodDisruptionBudgetList:
        ...
    def list_pod_security_policy(self, *, pretty: typing.Optional[str] = ..., allow_watch_bookmarks: typing.Optional[bool] = ..., _continue: typing.Optional[str] = ..., field_selector: typing.Optional[str] = ..., label_selector: typing.Optional[str] = ..., limit: typing.Optional[int] = ..., resource_version: typing.Optional[str] = ..., timeout_seconds: typing.Optional[int] = ..., watch: typing.Optional[bool] = ...) -> kubernetes.client.PolicyV1beta1PodSecurityPolicyList:
        ...
    def create_pod_security_policy(self, body: kubernetes.client.PolicyV1beta1PodSecurityPolicy, *, pretty: typing.Optional[str] = ..., dry_run: typing.Optional[str] = ..., field_manager: typing.Optional[str] = ...) -> kubernetes.client.PolicyV1beta1PodSecurityPolicy:
        ...
    def delete_collection_pod_security_policy(self, *, pretty: typing.Optional[str] = ..., body: typing.Optional[kubernetes.client.V1DeleteOptions] = ..., _continue: typing.Optional[str] = ..., dry_run: typing.Optional[str] = ..., field_selector: typing.Optional[str] = ..., grace_period_seconds: typing.Optional[int] = ..., label_selector: typing.Optional[str] = ..., limit: typing.Optional[int] = ..., orphan_dependents: typing.Optional[bool] = ..., propagation_policy: typing.Optional[str] = ..., resource_version: typing.Optional[str] = ..., timeout_seconds: typing.Optional[int] = ...) -> kubernetes.client.V1Status:
        ...
    def read_pod_security_policy(self, name: str, *, pretty: typing.Optional[str] = ..., exact: typing.Optional[bool] = ..., export: typing.Optional[bool] = ...) -> kubernetes.client.PolicyV1beta1PodSecurityPolicy:
        ...
    def replace_pod_security_policy(self, name: str, body: kubernetes.client.PolicyV1beta1PodSecurityPolicy, *, pretty: typing.Optional[str] = ..., dry_run: typing.Optional[str] = ..., field_manager: typing.Optional[str] = ...) -> kubernetes.client.PolicyV1beta1PodSecurityPolicy:
        ...
    def delete_pod_security_policy(self, name: str, *, pretty: typing.Optional[str] = ..., body: typing.Optional[kubernetes.client.V1DeleteOptions] = ..., dry_run: typing.Optional[str] = ..., grace_period_seconds: typing.Optional[int] = ..., orphan_dependents: typing.Optional[bool] = ..., propagation_policy: typing.Optional[str] = ...) -> kubernetes.client.V1Status:
        ...
    def patch_pod_security_policy(self, name: str, body: typing.Any, *, pretty: typing.Optional[str] = ..., dry_run: typing.Optional[str] = ..., field_manager: typing.Optional[str] = ..., force: typing.Optional[bool] = ...) -> kubernetes.client.PolicyV1beta1PodSecurityPolicy:
        ...
